DELIMITER //

ALTER TABLE `modules` CHANGE `Type` `Type` enum('regular','exam', 'bonus', 'extra') NOT NULL DEFAULT 'regular'//

DROP FUNCTION IF EXISTS AddSubmodule//
CREATE FUNCTION `AddSubmodule`  ( `TeacherID`   INT, 
									`ModuleID`    INT, 
									`MaxRate`     INT, 
									`Name`      VARCHAR(200) charset utf8, 
									`Description` VARCHAR(200) charset utf8,
									`ControlType` VARCHAR(30) charset utf8
								)   RETURNS int(11)
		NO SQL
BEGIN  
	DECLARE checker INT;  
	
	SET checker = -1;
	SELECT disciplines.ID 
	INTO checker 
	FROM `modules`
	INNER JOIN `disciplines` ON disciplines.ID = modules.DisciplineID
	WHERE   TeacherID = disciplines.AuthorID AND
			ModuleID = modules.ID 
	LIMIT 1;
	IF  checker <= 0
	THEN
			RETURN -1;
	END IF;


	SET checker = 0;
	SELECT MAX(submodules.OrderNum)
	INTO checker
	FROM `submodules`
	WHERE   ModuleID = submodules.ModuleID
	LIMIT 1;
	IF checker IS NULL THEN
		SET checker = 0;
	END IF;
	SET checker = checker + 1;

	IF Description = "" THEN
		INSERT INTO `submodules`  
				(   submodules.ModuleID, submodules.MaxRate, submodules.OrderNum, submodules.Name, submodules.Description, submodules.Type )
		VALUES  (   ModuleID, MaxRate, checker, Name, NULL, ControlType);
	ELSE 
		INSERT INTO `submodules`  
				(   submodules.ModuleID, submodules.MaxRate, submodules.OrderNum, submodules.Name, submodules.Description, submodules.Type )
		VALUES  (   ModuleID, MaxRate, checker, Name, Description, ControlType);
	END IF;
	
	RETURN  ( SELECT submodules.ID
				FROM `submodules`
				WHERE   submodules.ModuleID = ModuleID AND
						submodules.OrderNum = checker
				LIMIT 1
			);
END //

DROP FUNCTION IF EXISTS AddModuleExtra//
CREATE FUNCTION `AddModuleExtra`	(	`TeacherID` 	INT, 
										`DisciplineID` 	INT
									) 	RETURNS int(11)
    NO SQL
BEGIN  
    DECLARE checker, vModule INT;  					 	
    IF 	NOT InternalIsTeacherAuthor(TeacherID,DisciplineID)
    THEN
    	RETURN -1;
	END IF;

	SET checker = -1;
	SELECT modules.ID 
	INTO checker
	FROM `modules`
	WHERE 	DisciplineID = modules.DisciplineID AND 
			modules.Type = 4;
	IF checker > 0 THEN
		RETURN -2;
	END IF;


	INSERT INTO `modules` 	
			( 	modules.Name, modules.OrderNum, modules.DisciplineID, modules.Type )
	VALUES 	( 	'Добор баллов' , 2900666 , DisciplineID, 4 );

	SET vModule = -1;
	SELECT 	modules.ID
	INTO vModule
	FROM `modules`
	WHERE 	DisciplineID = modules.DisciplineID AND 
			modules.Type = 4
	LIMIT 1;
	IF vModule <= 0 THEN
		RETURN -1; 
	END IF;

	SET checker = AddSubmodule(TeacherID, vModule, 6, '', NULL, 'LandmarkControl');
	RETURN vModule;
END //


DROP FUNCTION IF EXISTS AddModule//
CREATE FUNCTION `AddModule`	(	`TeacherID` 	INT, 
								`DisciplineID` 	INT, 
								`Name` 			VARCHAR(200) charset utf8
							) 	RETURNS int(11)
    NO SQL
BEGIN  
    DECLARE checker INT;  					 
	
    IF 	NOT InternalIsTeacherAuthor(TeacherID,DisciplineID)
    THEN
    	RETURN -1;
	END IF;

	SET checker = 0;
	SELECT MAX(modules.OrderNum)
	INTO checker
	FROM `modules`
	WHERE 	DisciplineID = modules.DisciplineID AND
			modules.Type != 1
	LIMIT 1;
	IF checker IS NULL THEN
		SET checker = 0;
	END IF;
	SET checker = checker + 1;


	INSERT INTO `modules` 	
			( 	modules.Name, modules.OrderNum, modules.DisciplineID )
	VALUES 	(	Name , checker , DisciplineID );
	

	RETURN 	(	SELECT 	modules.ID
				FROM 	`modules`
				WHERE 	DisciplineID = modules.DisciplineID AND 
						checker = modules.OrderNum
				LIMIT 1 
			);
END //





SELECT  AddSubmodule(disciplines.AuthorID, modules.ID, 40, '', NULL, 'LandmarkControl') AS '1',
		AddSubmodule(disciplines.AuthorID, modules.ID, 40, '', NULL, 'LandmarkControl') AS '2'
FROM `modules`
INNER JOIN `disciplines` ON disciplines.ID = modules.DisciplineID
WHERE modules.Type = 2//


DELETE FROM `rating_table`
WHERE rating_table.SubmoduleID IN 
		(		SELECT submodules.ID
				FROM `modules`
				LEFT JOIN `submodules` ON submodules.ModuleID = modules.ID
				WHERE modules.Type = 2
		)//


SELECT AddModuleExtra(disciplines.AuthorID, disciplines.ID)
FROM `disciplines`//





DROP FUNCTION IF EXISTS AddSubmodule//
CREATE FUNCTION `AddSubmodule`  ( `TeacherID`   INT, 
									`ModuleID`    INT, 
									`MaxRate`     INT, 
									`Name`      VARCHAR(200) charset utf8, 
									`Description` VARCHAR(200) charset utf8,
									`ControlType` VARCHAR(30) charset utf8
								)   RETURNS int(11)
		NO SQL
BEGIN  
    DECLARE checker INT;  
	
	SET checker = -1;
	SELECT disciplines.ID 
	INTO checker 
	FROM `modules`
	INNER JOIN `disciplines` ON disciplines.ID = modules.DisciplineID
	WHERE   TeacherID = disciplines.AuthorID AND
			ModuleID = modules.ID 
	LIMIT 1;
	IF  checker <= 0 OR
			InternalIsMapLocked(checker)
	THEN
			RETURN -1;
	END IF;


	SET checker = 0;
	SELECT MAX(submodules.OrderNum)
	INTO checker
	FROM `submodules`
	WHERE   ModuleID = submodules.ModuleID
	LIMIT 1;
	IF checker IS NULL THEN
		SET checker = 0;
	END IF;
	SET checker = checker + 1;

	IF Description = "" THEN
		INSERT INTO `submodules`  
				(   submodules.ModuleID, submodules.MaxRate, submodules.OrderNum, submodules.Name, submodules.Description, submodules.Type )
		VALUES  (   ModuleID, MaxRate, checker, Name, NULL, ControlType);
	ELSE 
		INSERT INTO `submodules`  
				(   submodules.ModuleID, submodules.MaxRate, submodules.OrderNum, submodules.Name, submodules.Description, submodules.Type )
		VALUES  (   ModuleID, MaxRate, checker, Name, Description, ControlType);
	END IF;
	
	RETURN  ( SELECT submodules.ID
				FROM `submodules`
				WHERE   submodules.ModuleID = ModuleID AND
						submodules.OrderNum = checker
				LIMIT 1
			);
END // 

DROP FUNCTION IF EXISTS AddModule//
CREATE FUNCTION `AddModule`	(	`TeacherID` 	INT, 
								`DisciplineID` 	INT, 
								`Name` 			VARCHAR(200) charset utf8
							) 	RETURNS int(11)
    NO SQL
BEGIN  
    DECLARE checker INT;  					 
	
    IF 	NOT InternalIsTeacherAuthor(TeacherID,DisciplineID) OR
    	InternalIsMapLocked(DisciplineID) 
    THEN
    	RETURN -1;
	END IF;

	SET checker = 0;
	SELECT MAX(modules.OrderNum)
	INTO checker
	FROM `modules`
	WHERE 	DisciplineID = modules.DisciplineID AND
			modules.Type = 1
	LIMIT 1;
	IF checker IS NULL THEN
		SET checker = 0;
	END IF;
	SET checker = checker + 1;


	INSERT INTO `modules` 	
			( 	modules.Name, modules.OrderNum, modules.DisciplineID )
	VALUES 	(	Name , checker , DisciplineID );
	

	RETURN 	(	SELECT 	modules.ID
				FROM 	`modules`
				WHERE 	DisciplineID = modules.DisciplineID AND 
						checker = modules.OrderNum
				LIMIT 1 
			);
END //


DROP FUNCTION IF EXISTS AddModuleExtra//
CREATE FUNCTION `AddModuleExtra`	(	`TeacherID` 	INT, 
										`DisciplineID` 	INT
									) 	RETURNS int(11)
    NO SQL
BEGIN  
    DECLARE checker, vModule INT;  					 	
    IF 	NOT InternalIsTeacherAuthor(TeacherID,DisciplineID) OR
    	InternalIsMapLocked(DisciplineID) 
    THEN
    	RETURN -1;
	END IF;

	SET checker = -1;
	SELECT modules.ID 
	INTO checker
	FROM `modules`
	WHERE 	DisciplineID = modules.DisciplineID AND 
			modules.Type = 4;
	IF checker > 0 THEN
		RETURN -2;
	END IF;


	INSERT INTO `modules` 	
			( 	modules.Name, modules.OrderNum, modules.DisciplineID, modules.Type )
	VALUES 	( 	'Добор баллов' , 2900666 , DisciplineID, 4 );

	SET vModule = -1;
	SELECT 	modules.ID
	INTO vModule
	FROM `modules`
	WHERE 	DisciplineID = modules.DisciplineID AND 
			modules.Type = 4
	LIMIT 1;
	IF vModule <= 0 THEN
		RETURN -1; 
	END IF;

	SET checker = AddSubmodule(TeacherID, vModule, 8, '', NULL, 'LandmarkControl');
	RETURN vModule;
END //



DELIMITER ;